PipeWire: SPA Debug

PipeWire 0.3.37

Macros | Functions
SPA Debug

## Macros
#define | spa_debug(...) ({ fprintf(stderr, __VA_ARGS__);fputc('\n', stderr); })

## Functions
int | spa_debug_buffer (int indent, const struct spa_buffer *buffer)
int | spa_debug_dict (int indent, const struct spa_dict *dict)
int | spa_debug_format_value (const struct spa_type_info *info, uint32_t type, void *body, uint32_t size)
int | spa_debug_format (int indent, const struct spa_type_info *info, const struct spa_pod *format)
int | spa_debug_mem (int indent, const void *data, size_t size)
int | spa_debug_port_info (int indent, const struct spa_port_info *info)
int | spa_debug_pod_value (int indent, const struct spa_type_info *info, uint32_t type, void *body, uint32_t size)
int | spa_debug_pod (int indent, const struct spa_type_info *info, const struct spa_pod *pod)
const struct spa_type_info * | spa_debug_type_find (const struct spa_type_info *info, uint32_t type)
const char * | spa_debug_type_short_name (const char *name)
const char * | spa_debug_type_find_name (const struct spa_type_info *info, uint32_t type)
const char * | spa_debug_type_find_short_name (const struct spa_type_info *info, uint32_t type)
uint32_t | spa_debug_type_find_type (const struct spa_type_info *info, const char *name)

## Detailed Description

## Macro Definition Documentation

## ◆ spa_debug [1/5]

#define spa_debug | ( |  | ... | ) | ({ fprintf(stderr, __VA_ARGS__);fputc('\n', stderr); })

## ◆ spa_debug [2/5]

#define spa_debug | ( |  | ... | ) | ({ fprintf(stderr, __VA_ARGS__);fputc('\n', stderr); })

## ◆ spa_debug [3/5]

#define spa_debug | ( |  | ... | ) | ({ fprintf(stderr, __VA_ARGS__);fputc('\n', stderr); })

## ◆ spa_debug [4/5]

#define spa_debug | ( |  | ... | ) | ({ fprintf(stderr, __VA_ARGS__);fputc('\n', stderr); })

## ◆ spa_debug [5/5]

#define spa_debug | ( |  | ... | ) | ({ fprintf(stderr, __VA_ARGS__);fputc('\n', stderr); })

## Function Documentation

## ◆ spa_debug_buffer()

int spa_debug_buffer | ( | int | indent,
|  | const struct spa_buffer * | buffer
| ) |  |
| inline

References spa_data::chunk, spa_data::data, spa_meta::data, spa_meta_header::dts_offset, spa_data::fd, spa_data::flags, spa_meta_header::flags, spa_rectangle::height, spa_data::mapoffset, spa_data::maxsize, spa_chunk::offset, spa_meta_header::offset, spa_region::position, spa_meta_header::pts, spa_meta_region::region, spa_meta_header::seq, spa_chunk::size, spa_meta::size, spa_region::size, spa_debug, spa_debug_mem(), spa_debug_type_find_name(), SPA_META_Bitmap, SPA_META_Cursor, spa_meta_for_each, SPA_META_Header, SPA_META_VideoCrop, SPA_META_VideoDamage, spa_type_data_type, spa_type_meta_type, spa_chunk::stride, spa_data::type, spa_meta::type, spa_rectangle::width, spa_point::x, and spa_point::y.

## ◆ spa_debug_dict()

int spa_debug_dict | ( | int | indent,
|  | const struct spa_dict * | dict
| ) |  |
| inline

References spa_dict::flags, item::key, spa_dict::n_items, spa_debug, spa_dict_for_each, and item::value.

Referenced by spa_debug_port_info().

## ◆ spa_debug_format()

int spa_debug_format | ( | int | indent,
|  | const struct spa_type_info * | info,
|  | const struct spa_pod * | format
| ) |  |
| inline

References _SPA_TYPE_LAST, spa_pod_prop::key, spa_type_info::name, name, spa_pod::size, SPA_CHOICE_Enum, SPA_CHOICE_Flags, SPA_CHOICE_None, SPA_CHOICE_Range, SPA_CHOICE_Step, spa_debug_format_value(), spa_debug_type_find(), spa_debug_type_find_name(), spa_debug_type_short_name(), SPA_FORMAT_mediaSubtype, SPA_FORMAT_mediaType, spa_format_parse(), SPA_POD_BODY, spa_pod_get_values(), SPA_POD_OBJECT_FOREACH, SPA_POD_TYPE, SPA_PTROFF, spa_type_format, spa_type_media_subtype, spa_type_media_type, SPA_TYPE_Object, spa_types, spa_pod::type, spa_type_info::type, spa_pod_prop::value, and spa_type_info::values.

## ◆ spa_debug_format_value()

int spa_debug_format_value | ( | const struct spa_type_info * | info,
|  | uint32_t | type,
|  | void * | body,
|  | uint32_t | size
| ) |  |
| inline

References spa_pod_array_body::child, spa_fraction::denom, spa_rectangle::height, spa_fraction::num, spa_pod::size, spa_debug_format_value(), spa_debug_type_find_short_name(), SPA_POD_ARRAY_BODY_FOREACH, SPA_TYPE_Array, SPA_TYPE_Bitmap, SPA_TYPE_Bool, SPA_TYPE_Bytes, SPA_TYPE_Double, SPA_TYPE_Float, SPA_TYPE_Fraction, SPA_TYPE_Id, SPA_TYPE_Int, SPA_TYPE_Long, SPA_TYPE_Rectangle, SPA_TYPE_String, spa_pod::type, spa_type_info::values, and spa_rectangle::width.

Referenced by spa_debug_format(), and spa_debug_format_value().

## ◆ spa_debug_mem()

int spa_debug_mem | ( | int | indent,
|  | const void * | data,
|  | size_t | size
| ) |  |
| inline

References spa_debug.

Referenced by spa_debug_buffer(), and spa_debug_pod_value().

## ◆ spa_debug_pod()

int spa_debug_pod | ( | int | indent,
|  | const struct spa_type_info * | info,
|  | const struct spa_pod * | pod
| ) |  |
| inline

References spa_debug_pod_value(), SPA_POD_BODY, SPA_POD_BODY_SIZE, SPA_POD_TYPE, and SPA_TYPE_ROOT.

## ◆ spa_debug_pod_value()

int spa_debug_pod_value | ( | int | indent,
|  | const struct spa_type_info * | info,
|  | uint32_t | type,
|  | void * | body,
|  | uint32_t | size
| ) |  |
| inline

References spa_pod_array_body::child, spa_pod_choice_body::child, spa_fraction::denom, spa_pod_choice_body::flags, spa_pod_prop::flags, spa_rectangle::height, spa_pod_object_body::id, spa_pod_prop::key, spa_type_info::name, spa_fraction::num, spa_pod_control::offset, spa_pod::size, spa_debug, spa_debug_mem(), spa_debug_pod_value(), spa_debug_type_find(), spa_debug_type_find_name(), SPA_POD_ARRAY_BODY_FOREACH, SPA_POD_BODY, SPA_POD_CHOICE_BODY_FOREACH, SPA_POD_CONTENTS, SPA_POD_FOREACH, SPA_POD_OBJECT_BODY_FOREACH, SPA_POD_SEQUENCE_BODY_FOREACH, SPA_TYPE_Array, SPA_TYPE_Bitmap, SPA_TYPE_Bool, SPA_TYPE_Bytes, spa_type_choice, SPA_TYPE_Choice, spa_type_control, SPA_TYPE_Double, SPA_TYPE_Fd, SPA_TYPE_Float, SPA_TYPE_Fraction, SPA_TYPE_Id, SPA_TYPE_Int, SPA_TYPE_Long, SPA_TYPE_None, SPA_TYPE_Object, SPA_TYPE_Pointer, SPA_TYPE_Rectangle, SPA_TYPE_ROOT, SPA_TYPE_Sequence, SPA_TYPE_String, SPA_TYPE_Struct, spa_pod::type, spa_pod_choice_body::type, spa_pod_object_body::type, spa_pod_pointer_body::type, spa_pod_control::type, spa_type_info::type, spa_pod_sequence_body::unit, spa_pod_pointer_body::value, spa_pod_prop::value, spa_pod_control::value, spa_type_info::values, and spa_rectangle::width.

Referenced by spa_debug_pod(), and spa_debug_pod_value().

## ◆ spa_debug_port_info()

int spa_debug_port_info | ( | int | indent,
|  | const struct spa_port_info * | info
| ) |  |
| inline

References spa_fraction::denom, spa_port_info::flags, spa_fraction::num, spa_port_info::props, spa_port_info::rate, spa_debug, and spa_debug_dict().

## ◆ spa_debug_type_find()

const struct spa_type_info * spa_debug_type_find | ( | const struct spa_type_info * | info,
|  | uint32_t | type
| ) |  |
| inline

References spa_type_info::name, spa_debug_type_find(), SPA_ID_INVALID, SPA_TYPE_ROOT, spa_type_info::type, and spa_type_info::values.

Referenced by spa_debug_format(), spa_debug_pod_value(), spa_debug_type_find(), and spa_debug_type_find_name().

## ◆ spa_debug_type_find_name()

const char * spa_debug_type_find_name | ( | const struct spa_type_info * | info,
|  | uint32_t | type
| ) |  |
| inline

References spa_type_info::name, spa_debug_type_find(), and spa_type_info::type.

Referenced by pw_context_debug_port_params(), pw_control_add_link(), pw_control_new(), pw_impl_node_set_param(), pw_impl_port_set_param(), spa_debug_buffer(), spa_debug_format(), spa_debug_pod_value(), and spa_debug_type_find_short_name().

## ◆ spa_debug_type_find_short_name()

const char * spa_debug_type_find_short_name | ( | const struct spa_type_info * | info,
|  | uint32_t | type
| ) |  |
| inline

References spa_debug_type_find_name(), spa_debug_type_short_name(), and spa_type_info::type.

Referenced by spa_debug_format_value().

## ◆ spa_debug_type_find_type()

uint32_t spa_debug_type_find_type | ( | const struct spa_type_info * | info,
|  | const char * | name
| ) |  |
| inline

References spa_type_info::name, name, spa_debug_type_find_type(), SPA_ID_INVALID, SPA_TYPE_ROOT, spa_type_info::type, and spa_type_info::values.

Referenced by spa_debug_type_find_type().

## ◆ spa_debug_type_short_name()

const char * spa_debug_type_short_name | ( | const char * | name | ) |
| inline

References name.

Referenced by spa_debug_format(), and spa_debug_type_find_short_name().